// ---------------------------------------------------------------------------
//    ... EMA    ,  
//        " ".
// ---------------------------------------------------------------------------

#property indicator_separate_window
#property indicator_buffers 5
#property indicator_color1  PaleGreen
#property indicator_color2  Red
#property indicator_color3  Blue
#property indicator_color4  Aqua
#property indicator_color5  DeepPink
#property indicator_width1  3
#property indicator_width2  2
#property indicator_width3  2
#property indicator_minimum 0

//   .
extern string TimeFrame   = "Current time frame";
extern int    PERIOD           = 15;
extern string note             = "turn on Alert = true; turn off = false";
extern bool   alertsOn         = true;
extern bool   alertsOnCurrent  = true;
extern bool   alertsMessage    = true;
extern bool   alertsSound      = true;
extern bool   alertsEmail      = false;
extern string soundfile        = "alert2.wav";
extern int    arrowSize        = 1;

//  .
double buf_av[], buf_up[], buf_dn[];
double arrowUp[];
double arrowDn[];
double trend[];
//  EMA.
double ema_k0, ema_k1;
//  .
int    work_period;
string indicatorFileName;
bool   returnBars;
bool   calculateValue;
int    timeFrame;

// .
int init() {
  IndicatorShortName(StringConcatenate(
    "AZZX - EMA VOLUME (", PERIOD, ")"));
  IndicatorDigits(0);
  IndicatorBuffers(6);
  SetIndexBuffer(0, buf_av);  
  SetIndexBuffer(1, buf_up);
  SetIndexBuffer(2, buf_dn);
  SetIndexBuffer(3, arrowUp);  SetIndexStyle(3,DRAW_ARROW,0,arrowSize); SetIndexArrow(3,233);
  SetIndexBuffer(4, arrowDn);  SetIndexStyle(4,DRAW_ARROW,0,arrowSize); SetIndexArrow(4,234);
  SetIndexBuffer(5, trend);
  
  SetIndexLabel(0, "HALF OF AVERAGE VOLUME");
  SetIndexLabel(1, "UP VOLUME");
  SetIndexLabel(2, "DOWN VOLUME");

  ema_k0 = 2.0 / (PERIOD + 1);
  ema_k1 = 1.0 - ema_k0;
  
  work_period = Bars - PERIOD - 2;
   
   //
   //
   //
   //
   //
       
   indicatorFileName = WindowExpertName();
   returnBars        = TimeFrame == "returnBars";     if (returnBars)     return(0);
   calculateValue    = TimeFrame == "calculateValue"; if (calculateValue) return(0);
   timeFrame         = stringToTimeFrame(TimeFrame);
          
   //
   //
   //
   //
   //
   

  return(0);
}

//  .
int start() {
   int i,j,counted_bars=IndicatorCounted();
   double u, d;
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);
           if (returnBars) { buf_av[0] = limit+1; return(0); }

  
   if (calculateValue || timeFrame == Period())
   {
     for(i = limit; i >= 0; i--) 
      {   
      if(i > work_period) 
      {
         buf_av[i] = EMPTY_VALUE;
         buf_up[i] = EMPTY_VALUE;
         buf_dn[i] = EMPTY_VALUE;
      } 
      else if(i == work_period) 
      {
         buf_av[i] = 0;
         buf_up[i] = 0;
         buf_dn[i] = 0;
      
         for(j = Bars - 1; j >= i; j--) 
         {
            calc(j, u, d);
      
            buf_av[i] += 0.5 * Volume[j];
            buf_up[i] += u   * Volume[j];
            buf_dn[i] += d   * Volume[j];
         }
      
         buf_av[i] /= PERIOD;
         buf_up[i] /= PERIOD;
         buf_dn[i] /= PERIOD;
      } 
      else 
      {
         calc(i, u, d);
      
         buf_av[i] = buf_av[i + 1] * ema_k1 + 0.5 * Volume[i] * ema_k0;
         buf_up[i] = buf_up[i + 1] * ema_k1 + u   * Volume[i] * ema_k0;
         buf_dn[i] = buf_dn[i + 1] * ema_k1 + d   * Volume[i] * ema_k0;
      }
      trend[i]   = trend[i+1];
      arrowUp[i] = EMPTY_VALUE;
      arrowDn[i] = EMPTY_VALUE;
         if (buf_up[i] > buf_dn[i]) trend[i] = 1;
         if (buf_up[i] < buf_dn[i]) trend[i] =-1;
         if (trend[i] != trend[i+1])
         if (trend[i]==1) 
               arrowUp[i] = buf_dn[i]-iATR(NULL,0,20,i)/2;
         else  arrowDn[i] = buf_up[i]+iATR(NULL,0,20,i)/2;
      }
      
      //
      //
      //
      //
      //
      
      if (alertsOn)
      {
        if (alertsOnCurrent)
             int whichBar = 0;
        else     whichBar = 1;
        if (trend[whichBar] != trend[whichBar+1])
        if (trend[whichBar] == 1)
              doAlert("Buy");
        else  doAlert("Sell");       
      }
      return(0);
   }
   
   //
   //
   //
   //
   //

   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for (i=limit; i>=0; i--)
   {
       int y = iBarShift(NULL,timeFrame,Time[i]);               
       int x = iBarShift(NULL,timeFrame,Time[i+1]);               
          buf_av[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",PERIOD,"",alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,soundfile,0,y);
          buf_up[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",PERIOD,"",alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,soundfile,1,y);
          buf_dn[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",PERIOD,"",alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,soundfile,2,y);
          arrowUp[i] = EMPTY_VALUE;
          arrowDn[i] = EMPTY_VALUE;
          if (x!=y)
          {
             arrowUp[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",PERIOD,"",alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,soundfile,3,y);
             arrowDn[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",PERIOD,"",alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,soundfile,4,y);
          }
   }
   return(0);
}

//    .
void calc(int bar, double &up, double &dn) {
  if(High[bar] == Low[bar]) {
    up = 0;
    dn = 0;
    
    return;
  }

  double range = High[bar] - Low[bar];
  double path  = 2.0 * range - MathAbs(Open[bar] - Close[bar]);

  if(Close[bar] > Open[bar]) {
    up = range / path;
    dn = 1.0 - up;
  } else {
    dn = range / path;
    up = 1.0 - dn;
  }
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(timeFrameToString(Period())+" "+Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," azzx_emavol ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," azzx_emavol "),message);
             if (alertsSound)   PlaySound(soundfile);
      }
}
      
      
//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}

      